/***************************************************************************
                          guidatedsingletransfer.cpp  -  description
                             -------------------
    begin                : Sa Nov 13 2004
    copyright            : (C) 2004 by Marcel Mulch
    email                : marcel@mulch-online.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "globals.h"
#include "guidatedsingletransfer.h"
#include <qdatetimeedit.h>
#include <qlabel.h>
#include <qcombobox.h>
#include <qspinbox.h>
#include <qlineedit.h>

/**
*constructor of GuiSingleTransfer
*
*@param main a pointer on moneypenny´s main class
*@param parent a pointer on the main widgets widget stack
*@param name widgets title
*@param hobit the hobit object, needed for hbci functions
*/
GuiDatedSingleTransfer::GuiDatedSingleTransfer(QWidget *parent, GuiMain* guimain, const char *name, HoBIT* hobit )
:GuiTransferForm(parent, guimain, name, hobit) {
	// hide not needed input fields
 	formNameLabel->setText(tr("Dated Transfer"));
 	textLabelLast->hide();
	dateEditLast->hide();
	textLabelTurnus->hide();
	comboBoxTurnus->hide();
	textLabelDay->hide();
	spinBoxDay->hide();

	 refresh();

	
}

/**
*destructor of GuiSingleTransfer
*/
GuiDatedSingleTransfer::~GuiDatedSingleTransfer(){
	qDebug("Destructor GuiDatedSingleTransfer finished");
}

/** 
* called function after pressing button of formular,
* gets current inputs of formular for transferjob  
*/
void GuiDatedSingleTransfer::accept(){

// check if all necessary fields are not empty, otherwise errormessage
if(lineEditOtherName->text() == ' ' || lineEditOtherBankCode->text() == ' ' 
  || lineEditOtherAccountId->text() == ' ' 
  || lineEditValue->text() == ' ')
  QMessageBox::warning( this,
                        tr("Error"),
                          tr("Please fill in all fields. Purpose fields are not mandatory."),
                         "&OK",
                          QString::null, 0, 1 ) ;
else{

// current lineedit-inputs to vars
QString ourAccount = _main->getCurrentAccount();
QString name = lineEditOtherName->text();
QString bankCode = lineEditOtherBankCode->text();
QString accountId = lineEditOtherAccountId->text();
QString purpose1 =  lineEditPurpose->text();
QString purpose2 =  lineEditPurpose2->text();
QString value = lineEditValue->text();
QDate d = dateEditFirst->date();
Date date(d.day(), d.month(), d.year());

Value val(value.ascii(), "EUR");

list<string> oname;
oname.push_back(name.ascii());

list<string> purpose;
purpose.push_back(purpose1.ascii());
purpose.push_back(purpose2.ascii());

// text for show all inputs of form, used in messagebox
QString text =    "Sie sind dabei folgende �erweisung zu t�igen \n";
text += "\nAusgangskonto:      ";
text +=  ourAccount;
text +=  "\nEmpf�gerkonto:   ";
text += accountId;
text += "\nbei Bank:              ";
text += bankCode;
text += "\nBetrag                  ";
text += value;
text += " EUR";
text += "\n\nVerwendungszweck:\n";
text += purpose1;
text += "\n";
text += purpose2;

// messagebox opens for show input of form and ask for confirm, alternatively decline
bool no = QMessageBox::question( this,
                                 "Auftrag bet�igen",
                                   text,
                                  "&Ja", "&Nein",
                                   QString::null, 0, 1 ) ;
      // after confirm: create and send job 
      if (!no) {
       _hobit->createJobSingleTransfer(  SKIP_FALSE_TRANSACTIONS,       // skipbad
                                         MONEYPENNY_DEFAULT_COUNTRY,                          // country
                                         "*",                            // bankcode
                                         ourAccount.ascii(),      // accountid
                                         "",                            // accountSubId
                                         MONEYPENNY_DEFAULT_COUNTRY,                          // other country
                                         bankCode.ascii(),       // other bankcode
                                         accountId.ascii(),        // other account
                                         oname,                    // other name
                                         purpose,                    // purpose
                                         val,                           // value
                                         51,                            // textkey
                                         date);                       // date
      _hobit->createJobGetDatedTransfers();
      if(_main->askForSend())
        _main->slotSendNow();
      _main->widgetStack->raiseWidget(DATED_TRANSFERS_WIDGET);

      }
  }
}

