/***************************************************************************
                          guidatedtransfers.h  -  description
                             -------------------
    begin                : Do Nov 11 2004
    copyright            : (C) 2004 by Marcel Mulch
    email                : marcel@mulch-online.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GUIDATEDTRANSFERS_H
#define GUIDATEDTRANSFERS_H

#include <qwidget.h>
#include <qwidgetstack.h>
#include <qptrvector.h>
#include "guidatedtransfersbase.h"
#include "hobit.h"
#include "guimain.h"
#include "datedtransfer.h"
#include "listviewitems.h"


class GuiMain;

/**
* class for a dialog, which shows a list of all dated transactions
*/

class GuiDatedTransfers : public GuiDatedTransfersBase  {
   Q_OBJECT
public: 
  
  /**
  *this is the constructor for the dialog
  *
  *@param main
  *@param parent the parent dialog of this widget
  *@param name widgets title
  *@param hobit
  */
	GuiDatedTransfers(QWidget *parent, GuiMain *guimain, const char *name=0, HoBIT* hobit=0);
	~GuiDatedTransfers();
   
   /** 
   * creates list for dated transfers
   */	
   bool setList(list<Pointer<DatedTransfer> > datedtransfers);
   /** 
   * updates the listview depending on the selected account 
   */
   virtual  void slotChangeAccount();
   /** 
   * creates job of dated transfers and send 
   */
   void slotGet();
   /** 
   * executed when user performs a double click on a list item 
   */
   void slotSelectItem();
   /** 
   * deletes an existing dated transfer job
   */
   void slotDeleteDatedTransfer();
   /** 
   * set accountlabel to current account
   */
   void refresh();
   /** 
   * Read property of QPtrList<DatedTransferItem> _DatedTransferList. 
   */
	QPtrList<DatedTransferItem>  getDatedTransferList()const;

/** set hobit object*/
  void setHoBIT(HoBIT* hobit){
   _hobit = hobit;
  }
signals:
 void raiseWidget(int);

private:
    HoBIT* _hobit;
    GuiMain* _main;
	QPtrList<DatedTransferItem> _DatedTransferList;

public slots: // Public slots
  /** 
  *raises widget of dated single transfer formular 
  */
  void slotNewDatedTransfer();
  /** 
  *executed when user performs a double click on a list item
  *parameters for check which item is selected
  */
  void slotSelectItem(int row, int col, int button, const QPoint & mousePos);


};



#endif

