/***************************************************************************
 *   Copyright (C) 2004 by Walter Roth                                     *
 *   walter@amd2600-roth                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "guihardwareconfig.h"
#include <qstring.h>
#include <qmessagebox.h>

/**
*this is the constructor of class for hardware configuration
*
*@param main 
*@param parent the parent dialog of this widget
*@param name widgets title
*@param hobit
*/
GuiHardwareConfig::GuiHardwareConfig(QWidget * parent, GuiMain *guimain, const char *name)
   :GuiHardwareConfigBase(parent, name)
{
  _main = guimain;
}

void GuiHardwareConfig::modemconfig()
{ 
  _process = new QProcess(_main);
  //_process->addArgument("kdesu");
  _process->addArgument("modemlink");
  _process->start();
}

/** destructor*/
GuiHardwareConfig::~GuiHardwareConfig(){
  qDebug("Destructor GuiHardwareConfig finished");
}


void GuiHardwareConfig::isdnconfig()
{
 _process = new QProcess(_main);
 //_process->addArgument("kdesu");
 _process->addArgument("isdn-config");
 _process->start();
}

void GuiHardwareConfig::dslconfig()
{
 _process = new QProcess(_main);
 //_process->addArgument("kdesu");
 _process->addArgument("/usr/sbin/pppoeconf");
 _process->start();
}

void GuiHardwareConfig::lanconfig()
{
  _process = new QProcess(_main);
  //_process->addArgument("kdesu");
  _process->addArgument("/usr/sbin/netcardconfig");
  _process->start();
}

void GuiHardwareConfig::printerconfig()
{
  //_main->slotRaiseWidget(PRINTER_CONFIG_WIDGET);
  _process = new QProcess(_main);
  //_process->addArgument("kdesu");
  _process->addArgument("cupsconfig");
  _process->start();
}

void GuiHardwareConfig::homeconfig()
{
  _process = new QProcess(_main);
  //_process->addArgument("kdesu");
  _process->addArgument("/usr/sbin/mkpersistenthome");
  _process->start();
}

void GuiHardwareConfig::wlanconfig()
{
  _process = new QProcess(_main);
  //_process->addArgument("kdesu");
  _process->addArgument("rxvt");
  _process->addArgument("-bg");
  _process->addArgument("black");
  _process->addArgument("-fg");
  _process->addArgument("green");
  _process->addArgument("-cr");
  _process->addArgument("red");
  _process->addArgument("-ls");
  _process->addArgument("-e");
  _process->addArgument("/usr/sbin/wlcardconfig");
  _process->start();
}

void GuiHardwareConfig::gprsconfig()
{
  _process = new QProcess(_main);
  //_process->addArgument("kdesu");
  _process->addArgument("gprsconnect");
  _process->start();
}

void GuiHardwareConfig::saveconfig()
{
  _process = new QProcess(_main);
  //_process->addArgument("kdesu");
  _process->addArgument("/usr/sbin/saveconfig");
  _process->start();
}


void GuiHardwareConfig::accept()
{
  _main->slotShowLastVisibleWidget();
}



