/***************************************************************************
 *   Copyright (C) 2004 by Walter Roth                                     *
 *   walter@amd2600-roth                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "guiknownbanks.h"
#include <list>
#include <string>

#include <qtable.h>
using namespace std;


/**
*constructor of GuiKnownBanks
*
*@param parent a pointer on the main widgets widget stack
*@param name widgets title
*@param hobit the hobit object, needed for hbci functions
*/
GuiKnownBanks::GuiKnownBanks(QWidget *parent, const char *name, HoBIT* hobit)
 : GuiKnownBanksBase(parent, name)
{
	_hobit = hobit;
	_banks = _hobit->listOfAllKnownBanks();
	list<HoBIT_Bank>::iterator bit;
	
	//if (banks.empty()) new QListViewItem(listViewBanks, tr("No bank list available"), "", "");
        
         tableBanks->setColumnStretchable (0, true);
         tableBanks->setColumnStretchable (1, true);
         tableBanks->setColumnStretchable (2, true);
         tableBanks->setReadOnly(true);
         tableBanks->verticalHeader()->hide();
                   	
        //preset number of rows, this is a very slow operation
        int numBanks = 0;
	for (bit = _banks.begin(); bit != _banks.end(); bit++) //count the banks
         numBanks ++;        
        tableBanks->setNumRows(numBanks); 
        
        int row = 0;        
	for (bit = _banks.begin(); bit != _banks.end(); bit++)
	{
          tableBanks->setText(row, 0, "~ "+ (*bit).getBankId());
          tableBanks->setText(row, 1, (*bit).getBankName());
          tableBanks->setText(row, 2, (*bit).getLocation());
          row++;
	}
	
}

/**
*constructor of GuiKnownBanks
*/
GuiKnownBanks::~GuiKnownBanks()
{
  qDebug("Destructor GuiKnownBanks finished");
}


