/***************************************************************************
                          guisingletransfer.cpp  -  description
                             -------------------
    begin                : Mo Nov 8 2004
    copyright            : (C) 2004 by Marcel Mulch
    email                : marcel@mulch-online.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "globals.h"
#include "guisingletransfer.h"
#include <qdatetimeedit.h>
#include <qlabel.h>
#include <qcombobox.h>
#include <qspinbox.h>
#include <qlineedit.h>

/**
*constructor of GuiSingleTransfer
*
*@param main a pointer on moneypenny´s main class
*@param parent a pointer on the main widgets widget stack
*@param name widgets title
*@param hobit the hobit object, needed for hbci functions
*/
GuiSingleTransfer::GuiSingleTransfer(QWidget *parent, GuiMain* guimain, const char *name, HoBIT* hobit )
:GuiTransferForm(parent, guimain, name, hobit) {
	//hide not needed Input-Fields:
	textLabelFirst->hide();
	dateEditFirst->hide();
	textLabelLast->hide();
	dateEditLast->hide();
	textLabelTurnus->hide();
	comboBoxTurnus->hide();
	textLabelDay->hide();
	spinBoxDay->hide();
	
}

/**
*destructor of GuiSingleTransfer
*/
GuiSingleTransfer::~GuiSingleTransfer(){
	qDebug("Destructor GuiSingleTransfer finished");
}

/** 
*called function after pressing button of formular,
*gets current inputs of formular for transferjob  
*/
void GuiSingleTransfer::accept(){

 // check if all necessary fields are not empty, otherwise errormessage
 if(lineEditOtherName->text() == ' ' || lineEditOtherBankCode->text() == ' ' 
    || lineEditOtherAccountId->text() == ' '    || lineEditValue->text() == ' ')
    QMessageBox::warning( this,
                          tr("Error"),
                          tr("Please fill in all fields. Purpose fields are not mandatory."),
                          tr("&OK"),
                          QString::null, 0, 1 ) ;
 else{ //no error
     // current lineedit-inputs to vars
     QString ourAccount = _main->getCurrentAccount();   
     QString name = lineEditOtherName->text();
     QString bankCode = lineEditOtherBankCode->text();
     QString accountId = lineEditOtherAccountId->text();
     QString purpose1 =  lineEditPurpose->text();
     QString purpose2 =  lineEditPurpose2->text();
     QString value = lineEditValue->text();
     
         
     Value val(value.ascii(), "EUR");
     
     list<string> oname;
     oname.push_back(name.ascii());
     
     list<string> purpose;
     purpose.push_back(purpose1.ascii());
     purpose.push_back(purpose2.ascii());
     
     // text for show all inputs of form, used in messagebox
     QString text =    tr("You are about to create the following transfer: ") +"\n\n";
     text += tr("From Account:      ") ;
     text +=  ourAccount + "\n";
     text +=  tr("To Account: ");
     text += accountId+ "\n";
     text += tr("At Bank:              ");
     text += bankCode+ "\n";
     text += tr("Amount:                 ");
     text += value;
     text += tr(" EUR")+ "\n\n";
     text += tr("\n\nPurpose:");
     text += purpose1+ "\n";
     text += purpose2 + "\n";
     
     // messagebox opens for show input of form and ask for confirm, alternatively decline
     bool no = QMessageBox::question( this,
                                      tr("Confirm transfer"),
                                      text,
                                      tr("&Yes"), tr("&No"),
                                      QString::null, 1, 0 ) ;
      // after confirm: create and send job 
      if (!no) {
       int err = _hobit->createJobSingleTransfer(  SKIP_FALSE_TRANSACTIONS,      // skipbad
                                                   MONEYPENNY_DEFAULT_COUNTRY,                          // country
                                                   "*",                            // bankcode
                                                   ourAccount.ascii(),      // accountid
                                                   "",                            // accountSubId
                                                   MONEYPENNY_DEFAULT_COUNTRY,                          // other country
                                                   bankCode.ascii(),       // other bankcode
                                                   accountId.ascii(),        // other account
                                                   oname,                    // other name
                                                   purpose,                    // purpose
                                                   val,                           // value
                                                   51,                            // textkey
                                                   Date()); 			// date
        
        if(err != HobitErrorSuccess)
          qDebug("GuiSingleTransfer::accept: Error creating JobSingleTransfer. Error Code: %i", err);
        if(_main->askForSend())
          _main->slotSendNow();
  //      _main->widgetStack->raiseWidget(GET_TRANSACTIONS_WIDGET);
      }//end if yes
  }//end no error
}

