/***************************************************************************
 *   Copyright (C) 2004 by Walter Roth                                     *
 *   walter@amd2600-roth                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef GUITRANSFERTEMPLATES_H
#define GUITRANSFERTEMPLATES_H

#include "guitransfertemplatesbase.h"
#include "guimain.h"
#include "hobit.h"

class GuiMain;

class GuiTransferTemplates : public GuiTransferTemplatesBase
{
  Q_OBJECT
public:
  GuiTransferTemplates(GuiMain* main = 0, QWidget* parent = 0, const char* name = 0, HoBIT* hobit = 0);
  ~GuiTransferTemplates();
  /*$PUBLIC_FUNCTIONS$*/

/** set hobit object*/
  void setHoBIT(HoBIT* hobit){
   _hobit = hobit;
  }
  

public slots:
  /*$PUBLIC_SLOTS$*/
  virtual void          select();
  virtual void          use();
  virtual void          remove();
  virtual void          cancel();
  virtual void          refresh();

private:
   HoBIT* _hobit;
   GuiMain* _main;
   list <Pointer<HoBIT_TransferTemplate> > _templates;

protected slots:
  /*$PROTECTED_SLOTS$*/

};

#endif

