/***************************************************************************
                          transaction.h  -  description
                             -------------------
    begin                : Sa Nov 6 2004
    copyright            : (C) 2004 by Marcel Mulch
    email                : marcel@mulch-online.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TRANSACTION_H
#define TRANSACTION_H


#include <string>
#include <list>
#include <iostream>
using namespace std;

#include <openhbci2/date.h>
#include <openhbci2/value.h>
#include <gwenhywfar/db.h>
using namespace HBCI;




/**Simple class for storing transaction data
  *@author Marcel Mulch
  */
class Transaction {

private:

  Date _valutaDate;
  Date _date;
  Date _storedate;

  Value _value;
  string _key;
  string _custref;
  string _textkey;
  string _text;
  string _primanota;
  string _othername;
  string _ourbankcode;
  string _ouraccountId;
  string _otherbankcode;
  string _otheraccountId;
 
  list<string> _purposeLines;

public:
	Transaction(GWEN_DB_NODE *db);
	virtual ~Transaction();

  void setValutaDate(const Date& d) {_date = d;};
  void setDate(const Date& d) {_valutaDate = d;};
  void setStoredate(const Date& d) {_storedate = d;};
  void setValue(const Value& v) {_value = v;};

  void setKey(const string& key) {_key = key;};
  void setCustref(const string& cr) {_custref = cr;};
  void setTextkey(const string& tk) {_textkey = tk;};
  void setText(const string& text) {_text = text;};
  void setPrimanota(const string& prim) {_primanota = prim;};
  void setOurBankCode(const string& bc) {_ourbankcode = bc;};
  void setOurAccountId(const string& accId) {_ouraccountId = accId;};
  void setOtherBankCode(const string& bc) {_otherbankcode = bc;};
  void setOtherAccountId(const string& accId) {_otheraccountId = accId;};
  void setOtherName(const string& othername) {_othername = othername;};

  const Date& valutaDate(){return _valutaDate;};
  const Date& date(){return _date;};
  const Date& storeDate(){return _storedate;};
  const Value& value(){return _value;};

  const string& key(){return _key;};
  const string& custref(){return _custref;};
  const string& text(){return _text;};
  const string& textkey(){return _textkey;};
  const string& primanota(){return _primanota;};
  const string& ourbankcode(){return _ourbankcode;};
  const string& ouraccountId(){return _ouraccountId;};
  const string& otherbankcode(){return _otherbankcode;};
  const string& otheraccountId(){return _otheraccountId;};
  const string& othername(){return _othername;};
  
    /** Write property of list<string> _purposes. */
  virtual void setPurposeLines( const list<string>& _newVal);
  /** Read property of list<string> _purposes. */
  virtual const list<string>& purposeLines();
  
};
#endif
